%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PV
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mpc.PVtype = 3; %1-constant current  2-constant power  3-current+AC/DC

%1-Rated power [MVA]
%2-Rated voltage 
%3-LG (H)   0.02308 
%4-RG (ohm)   0.000238
%5-Gdc (ohm^-1)
%6-Cdc (uF)
%7-ipv_s (A)  not used
%8-Rpv (ohm)
%9-Vpv (V)
%10-Vdc' (V)
pv_con = [ 
  2 690 0.002 0.000238 1e-6 1e4  7616.2  0.0366  568.128  289.3;
  %2 690 0.0005 0.000238 1e-5 1e4  7616.2  0.0366  568.128  289.3;
  %2 690 0.008 0.000238 0.01 1e5  312.2632  0.4062  258.2400  131.5;
  ];

%% penetration of solar (connected bus#, reactance, P[MW])
if norm(gamma_pv) > 0
  %mpc.PVdata = [[22; 0.01; gamma_pv(1)*pv_con(1,1)]]; 
  mpc.PVdata = [[66; 0.01; gamma_pv(1)*pv_con(1,1)]]; 
else
  mpc.PVdata = [];
end

% 1-tauG
% 2-Kp_dG (positive)
% 3-Ki_dG (positive)
% 4-Kp_qG (negative)
% 5-Ki_qG (negative; larger than 1/(4*vdg_star))
% 6-duty saturation 
pvp = [  
  0.7  -0.01  -0.1  0.01  0.1  1e0;
  %3.0  -0.005  -0.01  0.005  0.01  1e0;
  %0.7  -0.01  -0.1  0.01  0.1  1e5;
  %0.08  0.1  1  -0.1  -1  1e5;
  ];