%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot Details of Syncgen States
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
col = [0 0 1; 1 0 0; 0 0.8 0; 1 1 0; 0.5 0.5 0.1]; 
figure;
% ***********************************
% Angle difference w.r.t. 16th syncgen[deg]
% A1=Blue, A2=Red, A3=Gre, A4=Yel, A5=Pur
%   note: area5 includes base gen only 
% ***********************************
subplot(2,3,1);
for ai=1:5
  plot(t, thdiff(:, area{ai}),'Color',col(ai,:),'linewidth',1); hold on; 
end
grid on; ylabel('ang diff[deg]'); xlim([t(1) t(end)]); 

% ***********************************
% Frequency difference [Hz]
% ***********************************
subplot(2,3,2);
%for ai=1:5
%  plot(t, ome(:, area{ai}),'Color',col(ai,:),'linewidth',1); hold on; 
%end
plot(t, ome,'b-','linewidth',1); hold on; 
grid on; ylabel('ome[Hz]'); xlim([t(1) t(end)]); 

% ***********************************
% Bus voltage magnitude (pu) & angle (deg)
% ***********************************
subplot(2,3,3);
for ai=1:5
  plot(t, vabs_G(:, area{ai}),'Color',col(ai,:),'linewidth',1); hold on; 
end
grid on; ylabel('V(pu)'); xlim([t(1) t(end)]); 

subplot(2,3,4);
for ai=1:5
  plot(t, uPSS(:, area{ai}),'Color',col(ai,:),'linewidth',1); hold on; 
  plot([t(1),t(end)], [pss_con(1,9),pss_con(1,9)],'k--','linewidth',1); 
  plot([t(1),t(end)], -[pss_con(1,9),pss_con(1,9)],'k--','linewidth',1); 
  %plot(t, (180/pi)*vang_G(:, area{ai}),'Color',col(ai,:),'linewidth',1); hold on; 
end
grid on; ylabel('PSS input (pu)'); xlim([t(1) t(end)]); 
%grid on; ylabel('th(deg)'); xlim([t(1) t(end)]); 

% ***********************************
% Active and Reactive power (MW)
% ***********************************
subplot(2,3,5);
for ai=1:5
  plot(t, mpc.baseMVA*real(PG(:, area{ai})),'Color',col(ai,:),'linewidth',1); hold on; 
end
grid on; ylabel('P(MW)'); xlim([t(1) t(end)]); 

subplot(2,3,6);
for ai=1:5
  plot(t, mpc.baseMVA*imag(PG(:, area{ai})),'Color',col(ai,:),'linewidth',1); hold on; 
end
grid on; ylabel('Q(MM)'); xlim([t(1) t(end)]); 
