%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot Details of Solar System States
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
col = [0 0 1; 1 0 0; 0 0.8 0; 1 1 0; 0.5 0.5 0.1]; 
figure;
for j=1:NP
  % ***********************************
  % Duty cycle
  % ***********************************
  subplot(3,1,1);
  plot(t, mGpv{j}(:, 1),'b-','linewidth',1); hold on; 
  plot(t, mGpv{j}(:, 2),'r-','linewidth',1);
  grid on; ylabel('Duty'); xlim([t(1) t(end)]);  legend('mdG', 'mqG'); %ylim([-1 1])

  % ***********************************
  % Vdc (V)
  % ***********************************
  subplot(3,1,2);
  plot(t, vdc_pv(:, j),'linewidth',1);  hold on;
  grid on; ylabel('Vdc [V]'); xlim([t(1) t(end)]); 
  
  % ***********************************
  % iG (pu)
  % ***********************************
  subplot(3,1,3);
  plot(t, ig_pv(:,2*j-1),'b-','linewidth',1); hold on; 
  plot(t, ig_pv(:,2*j),'r-','linewidth',1); 
  grid on; ylabel('iG [pu]'); xlim([t(1) t(end)]); 
end
  